﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Devices.Gpio;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

namespace Candle
{
    public sealed partial class MainPage : Page
    {
        private GpioPin pin1;
        private GpioPin pin2;
        private GpioPin pin3;
        GpioPinValue value1 = GpioPinValue.High; //pin1 hetkeseis
        GpioPinValue value2 = GpioPinValue.High; //pin2 hetkeseis
        DispatcherTimer timer = new DispatcherTimer(); //ajamõõtur
        int stall = 1; //viiteloendur
        int stall_limit = 10; //viite piir
        Random rnd = new Random(); //juhusliku arvu generaator

        public MainPage()
        {
            this.InitializeComponent();
            InitGPIO();
        }
        private void InitGPIO()
        {
            // Seostab pin1, vastava ühendusega (viigiga) Raspberryl
            pin1 = GpioController.GetDefault().OpenPin(18);
            pin1.Write(value1);
            pin1.SetDriveMode(GpioPinDriveMode.Output);
        }

        private void Ticker(object sender, object e)
        {
            Switch(pin1, value1);
        }

        // Lülitus
        private void Switch(GpioPin pin, GpioPinValue gpv)
        {
            if (gpv == GpioPinValue.High)
            {
                gpv = GpioPinValue.Low;
                pin.Write(gpv);
            }
            else
            {
                gpv = GpioPinValue.High;
                pin.Write(gpv);
            }
        }

        // PWM pulsimõõtur
        private void Pulser(GpioPin p1, GpioPinValue gpv1, GpioPin p2, GpioPinValue gpv2)
        {
            if(gpv1 == gpv2)
            {
                Switch(p2, gpv2);
            }
        }
        // Nupud
        private void pin1Button(object sender, RoutedEventArgs e)
        {
            timer.Stop();
            Switch(pin1, value1);
        }
        private void pin2Button(object sender, RoutedEventArgs e)
        {
            timer.Stop();
            Switch(pin2, value2);
        }
        private void PWMButton(object sender, RoutedEventArgs e)
        {
            timer.Stop();
        }
        private void partyButton(object sender, RoutedEventArgs e)
        {
            timer.Start();
        }
    }
}
